#include <windows.h>
#include "tp_stub.h"


class tTJSNativeClassForRegExp : public tTJSDispatch
{
public:
	tTJSNativeClassForRegExp(tjs_char const *className) : tTJSDispatch(), classname(className) {
		self = this;
		classobj = TJSCreateNativeClassForPlugin(className, _CreateNativeInstance);
	}

	static void Link(iTJSDispatch2 *global) {
		Initialize();
		if (self) {
			self->Setup(global);
		}
	}
	static void Unlink(iTJSDispatch2 *global) {
		if (self) {
			self->Terminate(global);
			self->Release();
		}
		self = 0;
	}

	// Array.split I[o[Ch
	static tjs_error TJS_INTF_METHOD FuncCall(tTJSVariant *r, tjs_int n, tTJSVariant **p, iTJSDispatch2 *objthis) {
		return self ? self->Split(r, n, p, objthis) : TJS_E_FAIL;
	}

private:
	static tTJSNativeClassForRegExp * self;
	static iTJSNativeInstance * TJS_INTF_METHOD _CreateNativeInstance() {
		return self ? self->CreateNativeInstance() : NULL;
	}
	static void Initialize();

private:
	tTJSVariant origRegEx, arraySplit;
	void Setup(iTJSDispatch2 *global) {
		tTJSVariant val;
		if (TJS_SUCCEEDED(global->PropGet(0, classname, NULL, &val, global))) {
			origRegEx = val;
		}

		val.Clear();
		val = tTJSVariant(classobj, NULL);
		global->PropSet(
			TJS_MEMBERENSURE, // oȂꍇɂ͍쐬悤ɂtO
			classname, // o ( Ȃ炸 TJS_W( ) ň͂ )
			NULL, // qg ( {̓õnbVlANULL ł悢 )
			&val, // o^l
			global // ReLXg ( global ł悢 )
			);
		classobj->Release();

		val.Clear();
		if (TJS_SUCCEEDED(global->PropGet(0, TJS_W("Array"), NULL, &val, global))) {
			iTJSDispatch2 *array = val.AsObjectNoAddRef();
			if (TJS_SUCCEEDED(array->PropGet(0, TJS_W("split"), NULL, &arraySplit, array))) {
				val.Clear();
				val = tTJSVariant(this, NULL);
				array->PropSet(0, TJS_W("split"), NULL, &val, array);
			}
		}
	}
	void Terminate(iTJSDispatch2 *global) {
		global->DeleteMember(
			0, // tO ( 0 ł悢 )
			classname, // o
			NULL, // qg
			global // ReLXg
			);

		if (origRegEx.Type() == tvtObject) {
			global->PropSet(TJS_MEMBERENSURE, classname, NULL, &origRegEx, global);
		}

		if (arraySplit.Type() == tvtObject) {
			tTJSVariant val;
			if (TJS_SUCCEEDED(global->PropGet(0, TJS_W("Array"), NULL, &val, global))) {
				iTJSDispatch2 *array = val.AsObjectNoAddRef();
				array->PropSet(0, TJS_W("split"), NULL, &arraySplit, array);
			}
		}
	}

	tjs_error Split(tTJSVariant *r, tjs_int n, tTJSVariant **p, iTJSDispatch2 *objthis) {
		if(n >= 2 && p[0]->Type() == tvtObject) {
			tTJSVariantClosure clo = p[0]->AsObjectClosureNoAddRef();
			if(clo.Object) {
				// func call split(targetstring, reserved, purgeempty, this);
				tTJSVariant array(objthis, objthis), tvoid, dummy;
				tTJSVariant *params[] = { p[1], &tvoid, &tvoid, &array };
				if (n >= 3)  params[1] = p[2];
				if (n >= 4)  params[2] = p[3];
				static ttstr split(TJS_W("split"));
				if(TJS_SUCCEEDED(clo.FuncCall(0, split.c_str(), split.GetHint(),
											  &dummy, 4, params, NULL))) {
					if(r) *r = tTJSVariant(objthis, objthis);
					return TJS_S_OK;
				}
			}
		}
		return (arraySplit.AsObjectNoAddRef())->FuncCall(0, NULL, NULL, r, n, p, objthis);
	}

protected:
	tjs_char const *classname;
	tTJSNativeClassForPlugin * classobj;
	virtual iTJSNativeInstance *CreateNativeInstance() = 0;
};
tTJSNativeClassForRegExp* tTJSNativeClassForRegExp::self = 0;


// hacks

#define TJS_cdecl
#define TJS_strchr			wcschr

#define TJS_NATIVE_CLASSID_NAME tTJSNC_RegExp::ClassID
#define tTJSNativeClass tTJSNativeClassForRegExp

#define TJS_eTJSError TVPThrowExceptionMessage
inline void TVPThrowExceptionMessage(const tjs_nchar * msg) {
	ttstr msg_(msg);
	TVPThrowExceptionMessage(msg_.c_str());
}

#pragma warning (disable: 4996)
#pragma warning (disable: 4800)

#define TJS_USE_XPRESSIVE
#include "tjsRegExp.cpp"

void tTJSNativeClassForRegExp::Initialize()
{
	TJS::TJSCreateRegExpClass();
}


#define EXPORT(hr) extern "C" __declspec(dllexport) hr __stdcall

#ifdef _MSC_VER
#pragma comment(linker, "/EXPORT:V2Link=_V2Link@4")
#pragma comment(linker, "/EXPORT:V2Unlink=_V2Unlink@0")
#endif

//--------------------------------------
int WINAPI
DllEntryPoint(HINSTANCE /*hinst*/, unsigned long /*reason*/, void* /*lpReserved*/)
{
	return 1;
}

//---------------------------------------------------------------------------
static tjs_int GlobalRefCountAtInit = 0;

EXPORT(HRESULT) V2Link(iTVPFunctionExporter *exporter)
{
	// X^ȕ(KLq)
	TVPInitImportStub(exporter);

	// TJS ̃O[oIuWFNg擾
	iTJSDispatch2 * global = TVPGetScriptDispatch();
	if (global) {

		// o^
		tTJSNativeClassForRegExp::Link(global);

		// - global  Release 
		global->Release();
	}

	// ̎_ł TVPPluginGlobalRefCount ̒l
	GlobalRefCountAtInit = TVPPluginGlobalRefCount;
	// ƂčTĂBTVPPluginGlobalRefCount ͂̃vOC
	// ǗĂ tTJSDispatch hIuWFNg̎QƃJE^̑vŁA
	// ɂ͂ƓAȂȂĂȂƂȂȂB
	// ȂĂȂ΁Aǂʂ̂ƂŊ֐ȂǂQƂĂāA
	// vOC͉łȂƌƂɂȂB

	return S_OK;
}
//---------------------------------------------------------------------------
EXPORT(HRESULT) V2Unlink()
{
	// ggAvOC悤ƂƂɌĂ΂֐

	// 炩̏ŃvOCłȂꍇ
	// ̎_ E_FAIL Ԃ悤ɂB
	// ł́ATVPPluginGlobalRefCount  GlobalRefCountAtInit 
	// 傫ȂĂΎsƂƂɂB
	if (TVPPluginGlobalRefCount > GlobalRefCountAtInit) return E_FAIL;


	/*
		ANX̏ꍇAɁuIuWFNggpłvƂƂ
		m邷ׂ܂B{Iɂ́APlugins.unlink ɂvOC̉
		댯łƍlĂ ( Plugins.link ŃNAŌ
		ŃvOCAvOIƓɎIɉ̂g)B
	*/

	// - ܂ATJS ̃O[oIuWFNg擾
	iTJSDispatch2 * global = TVPGetScriptDispatch();
	if(global) {

		// n
		tTJSNativeClassForRegExp::Unlink(global);

		// - global  Release 
		global->Release();
	}

	// X^u̎gpI(KLq)
	TVPUninitImportStub();

	return S_OK;
}
